libdap::Structure Class Reference

Holds a structure (aggregate) type. More...

`#include <Structure.h>`

Inheritance diagram for libdap::Structure:

## Public Types

typedef stack< BaseType * > | btp_stack
typedef std::vector< BaseType * >::const_iterator | Vars_citer
typedef std::vector< BaseType * >::iterator | Vars_iter
typedef std::vector< BaseType * >::reverse_iterator | Vars_riter

## Public Member Functions

virtual void | add_var (BaseType *bt, Part part=nil)
virtual void | add_var_nocopy (BaseType *bt, Part part=nil)
virtual unsigned int | buf2val (void **)
| Reads the class data. More...
virtual bool | check_semantics (string &msg, bool all=false)
| Compare an object's current state with the semantics of its type. More...
virtual void | clear_local_data ()
virtual void | compute_checksum (Crc32 &checksum)
| include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum. More...
virtual bool | d4_ops (BaseType *b, int op)
| Evaluator a relop for DAP4. More...
virtual string | dataset () const
| Returns the name of the dataset used to create this instance. More...
virtual void | del_var (const string &name)
virtual void | del_var (Vars_iter i)
virtual bool | deserialize (UnMarshaller &um, DDS *dds, bool reuse=false)
| Receive data from the net. More...
virtual void | deserialize (D4StreamUnMarshaller &um, DMR &dmr)
virtual void | dump (ostream &strm) const
| dumps information about this object More...
virtual int | element_count (bool leaves=false)
| Count the members of constructor types. More...
virtual std::string | FQN () const
virtual AttrTable & | get_attr_table ()
virtual BaseType * | get_parent () const
BaseType * | get_var_index (int i)
Vars_iter | get_vars_iter (int i)
virtual void | intern_data (ConstraintEvaluator &eval, DDS &dds)
virtual void | intern_data ()
| Read data into this variable. More...
virtual bool | is_constructor_type () const
| Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable. More...
virtual bool | is_dap4 () const
virtual bool | is_in_selection ()
| Is this variable part of the current selection? More...
virtual bool | is_linear ()
| Check to see whether this variable can be printed simply. More...
virtual bool | is_simple_type () const
| Returns true if the instance is a numeric, string or URL type variable. More...
virtual bool | is_vector_type () const
| Returns true if the instance is a vector (i.e., array) type variable. More...
virtual int | length () const
| How many elements are in this variable. More...
virtual string | name () const
| Returns the name of the class instance. More...
Structure & | operator= (const Structure &rhs)
virtual bool | ops (BaseType *b, int op)
| Evaluate relational operators. More...
void | print_dap4 (XMLWriter &xml, bool constrained=false)
virtual void | print_decl (ostream &out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false)
| Print an ASCII representation of the variable structure. More...
virtual void | print_decl (FILE *out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false)
| Print an ASCII representation of the variable structure. More...
virtual void | print_val (FILE *out, string space="", bool print_decl_p=true)
| Prints the value of the variable. More...
virtual void | print_val (ostream &out, string space="", bool print_decl_p=true)
| Prints the value of the variable. More...
virtual void | print_xml (ostream &out, string space=" ", bool constrained=false)
virtual void | print_xml (FILE *out, string space=" ", bool constrained=false)
virtual void | print_xml_writer (XMLWriter &xml, bool constrained=false)
virtual BaseType * | ptr_duplicate ()
virtual bool | read ()
| simple implementation of read that iterates through vars and calls read on them More...
virtual bool | read_p ()
| Has this variable been read? More...
virtual bool | send_p ()
| Should this variable be sent? More...
virtual bool | serialize (ConstraintEvaluator &eval, DDS &dds, Marshaller &m, bool ce_eval=true)
| Move data to the net, then remove them from the object. More...
virtual void | serialize (D4StreamMarshaller &m, DMR &dmr, bool filter=false)
| Serialize a Constructor. More...
virtual void | set_attr_table (const AttrTable &at)
virtual void | set_in_selection (bool state)
| Set the in_selection property. More...
virtual void | set_is_dap4 (const bool v)
virtual void | set_leaf_sequence (int level=1)
| Traverse Structure, set Sequence leaf nodes. More...
virtual void | set_length (int)
| Set the number of elements for this variable. More...
virtual void | set_name (const string &n)
| Sets the name of the class instance. More...
virtual void | set_parent (BaseType *parent)
virtual void | set_read_p (bool state)
| Sets the value of the read_p property. More...
virtual void | set_send_p (bool state)
virtual void | set_synthesized_p (bool state)
virtual void | set_type (const Type &t)
| Sets the type of the class instance. More...
| Structure (const string &n)
| Structure (const string &n, const string &d)
| Structure (const Structure &rhs)
virtual bool | synthesized_p ()
virtual string | toString ()
virtual void | transfer_attributes (AttrTable *at)
virtual vector< BaseType * > * | transform_to_dap2 (AttrTable *parent_attr_table)
| DAP4 to DAP2 transform. More...
virtual void | transform_to_dap4 (D4Group *root, Constructor *container)
virtual Type | type () const
| Returns the type of the class instance. More...
virtual string | type_name () const
| Returns the type of the class instance as a string. More...
virtual unsigned int | val2buf (void *, bool)
| Loads class data. More...
virtual BaseType * | var (const string &name, bool exact_match=true, btp_stack *s=0)
| btp_stack no longer needed; use back pointers (BaseType::get_parent()) More...
virtual BaseType * | var (const string &n, btp_stack &s)
Vars_iter | var_begin ()
Vars_iter | var_end ()
Vars_riter | var_rbegin ()
Vars_riter | var_rend ()
virtual unsigned int | width (bool constrained=false) const
virtual D4Attributes * | attributes ()
virtual void | set_attributes (D4Attributes *)
virtual void | set_attributes_nocopy (D4Attributes *)

## Static Public Member Functions

static AttrTable * | make_dropped_vars_attr_table (vector< BaseType *> *dropped_vars)

## Protected Member Functions

void | m_duplicate (const Constructor &s)
void | m_duplicate (const BaseType &bt)
| Perform a deep copy. More...
BaseType * | m_exact_match (const string &name, btp_stack *s=0)
BaseType * | m_leaf_match (const string &name, btp_stack *s=0)

## Protected Attributes

bool | d_in_selection
bool | d_is_synthesized
std::vector< BaseType * > | d_vars

## Detailed Description

Holds a structure (aggregate) type.

This data type is used to hold a collection of related data types, in a manner roughly corresponding to a C structure. The member types can be simple or compound types, and can include other Structures.

The DAP2 structure is defined as a singly-linked list. This means that Structure elements can be accessed either by name, with the `var()` function, or by their position in the list, either with the overloaded version of `var()`, or the combination of the `first_var()` and `next_var()` functions.

The `val2buf()` and `buf2val()` functions only return the size of the structure. To read parts of a DAP2 Structure into an application program, use the `buf2val()` function of the element of the Structure in question.

Note that the predicate-setting functions `set_send_p()` and `set_read_p()` set their flags for the Structure as well as for each of the Structure's member elements.

Similar to C, you can refer to members of Structure elements with a `.'' notation. For example, if the Structure has a member Structure called`Tom'' and Tom has a member Float32 called `shoe_size'', then you can refer to Tom's shoe size as` Tom.shoe_size''.

Definition at line 83 of file Structure.h.

## Constructor & Destructor Documentation

## Structure() [1/3]

libdap::Structure::Structure | ( | const string & | n | ) |

The Structure constructor requires only the name of the variable to be created. The name may be omitted, which will create a nameless variable. This may be adequate for some applications.

Parameters

  n | A string containing the name of the variable to be created.

Definition at line 109 of file Structure.cc.

## Structure() [2/3]

libdap::Structure::Structure | ( | const string & | n,
|  | const string & | d
| ) |  |

The Structure server-side constructor requires the name of the variable to be created and the dataset name from which this variable is being created. Used on server-side handlers.

Parameters

  n | A string containing the name of the variable to be created.
  d | A string containing the name of the dataset from which this variable is being created.

Definition at line 121 of file Structure.cc.

## Structure() [3/3]

libdap::Structure::Structure | ( | const Structure & | rhs | ) |

The Structure copy constructor.

Definition at line 126 of file Structure.cc.

## Member Function Documentation

## add_var()

void libdap::Constructor::add_var | ( | BaseType * | bt,
|  | Part | part = `nil`
| ) |  |

virtual inherited

Adds an element to a Constructor.

Parameters

  bt | A pointer to the variable to add to this Constructor.
  part | Not used by this class, defaults to nil

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 407 of file Constructor.cc.

## add_var_nocopy()

void libdap::Constructor::add_var_nocopy | ( | BaseType * | bt,
|  | Part | part = `nil`
| ) |  |

virtual inherited

Adds an element to a Constructor.

Parameters

  bt | A pointer to thee variable to add to this Constructor.
  part | Not used by this class, defaults to nil

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 432 of file Constructor.cc.

## attributes()

D4Attributes * libdap::BaseType::attributes | ( |  | ) |

virtual inherited

DAP4 Attribute methods

Definition at line 590 of file BaseType.cc.

## buf2val()

virtual unsigned int libdap::Constructor::buf2val | ( | void ** | val | ) |

inline virtual inherited

Reads the class data.

Reads the class data into the memory referenced by val. The caller should either allocate enough storage to val to hold the class data or set `*val` to null. If *val is NULL, memory will be allocated by this function with `new()`. If the memory is allocated this way, the caller is responsible for deallocating that memory. Array and values for simple types are stored as C would store an array.

Deprecated:
  Use value() in the leaf classes.

Parameters

  val | A pointer to a pointer to the memory into which the class data will be copied. If the value pointed to is NULL, memory will be allocated to hold the data, and the pointer value modified accordingly. The calling program is responsible for deallocating the memory references by this pointer.

Returns
  The size (in bytes) of the information copied to val.

Implements libdap::BaseType.

Definition at line 118 of file Constructor.h.

## check_semantics()

bool libdap::Constructor::check_semantics | ( | string & | msg,
|  | bool | all = `false`
| ) |  |

virtual inherited

Compare an object's current state with the semantics of its type.

This function checks the class instance for internal consistency. This is important to check for complex constructor classes. For BaseType, an object is semantically correct if it has both a non-null name and type.

For example, an Int32 instance would return FALSE if it had no name or no type defined. A Grid instance might return FALSE for more complex reasons, such as having Map arrays of the wrong size or shape.

This function is used by the DDS class, and will rarely, if ever, be explicitly called by a DODS application program. A variable must pass this test before it is sent, but there may be many other stages in a retrieve operation where it would fail.

Returns
  Returns FALSE when the current state violates some aspect of the type semantics, TRUE otherwise.

Parameters

  msg | A returned string, containing a message indicating the source of any problem.
  all | For complex constructor types (Grid, Sequence, Structure), this flag indicates whether to check the semantics of the member variables, too.

See also
  DDS::check_semantics

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 792 of file Constructor.cc.

## clear_local_data()

virtual void libdap::BaseType::clear_local_data | ( |  | ) |

inline virtual inherited

Remove any read or set data in the private data of the variable, setting read_p() to false. Used to clear any dynamically allocated storage that holds (potentially large) data. For the simple types, this no-op version is all that's needed. Vector and some other classes define a special version and have serialize() implementations that call it to free data as soon as possible after sending it.

Note
  Added 7/5/15 jhrg
  Any specialization of this should make sure to reset the read_p property.

Reimplemented in libdap::Sequence, libdap::Vector, libdap::D4Sequence, and libdap::D4Opaque.

Definition at line 179 of file BaseType.h.

## compute_checksum()

void libdap::Constructor::compute_checksum | ( | Crc32 & | checksum | ) |

virtual inherited

include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.

Parameters

  checksum | A Crc32 instance that holds the current checksum.

Implements libdap::BaseType.

Definition at line 550 of file Constructor.cc.

## d4_ops()

bool libdap::BaseType::d4_ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluator a relop for DAP4.

This method is used by the filter expression evaluation code in DAP4. Each of the 'data type' classes that support relops must overload this method. In an expression of the form arg1 op arg2, this object is arg1, the parameter 'b' is arg2 and op is the relational operator.

Note
  I used the same relop codes for DAP4 as in the DAP2 parser/scanner which makes for some coupling between them, but cuts way down on the duplication of the evaluator logic, which is somewhat involved.

Parameters

  b | The second argument in the relational expression
  op | The infix relational operator

Returns
  True if the expression is true, False otherwise.

Reimplemented in libdap::Str, libdap::Int32, libdap::Float32, libdap::Byte, libdap::Float64, libdap::Int16, libdap::Int64, libdap::UInt64, and libdap::Int8.

Definition at line 1273 of file BaseType.cc.

## dataset()

string libdap::BaseType::dataset | ( |  | ) | const

virtual inherited

Returns the name of the dataset used to create this instance.

A dataset from which the data is to be read. The meaning of this string will vary among different types of data sources. It may be the name of a data file or an identifier used to read data from a relational database.

Definition at line 349 of file BaseType.cc.

## del_var()

void libdap::Constructor::del_var | ( | const string & | n | ) |

virtual inherited

Remove an element from a Constructor.

Parameters

  n | name of the variable to remove

Definition at line 448 of file Constructor.cc.

## deserialize() [1/2]

bool libdap::Constructor::deserialize | ( | UnMarshaller & | um,
|  | DDS * | dds,
|  | bool | reuse = `false`
| ) |  |

virtual inherited

Receive data from the net.

Receives data from the network connection identified by the `source` parameter. The data is put into the class data buffer according to the input `dds`.

This function is only used on the client side of the DODS client/server connection.

Parameters

  um | An UnMarshaller that knows how to deserialize data types
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure. This would have been received from the server in an earlier transmission.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect.

Returns
  Always returns TRUE.

Exceptions

  Error | when a problem reading from the UnMarshaller is found.

See also
  DDS

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Sequence, and libdap::D4Sequence.

Definition at line 540 of file Constructor.cc.

## deserialize() [2/2]

void libdap::Constructor::deserialize | ( | D4StreamUnMarshaller & | um,
|  | DMR & | dmr
| ) |  |

virtual inherited

The DAP4 deserialization method.

Parameters

  um |
  dmr |

Exceptions

  Error | or InternalErr

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Sequence, and libdap::D4Group.

Definition at line 609 of file Constructor.cc.

## dump()

void libdap::Structure::dump | ( | ostream & | strm | ) | const

virtual

dumps information about this object

Displays the pointer value of this instance and information about this instance.

Parameters

  strm | C++ i/o stream to dump the information to

Returns
  void

Reimplemented from libdap::Constructor.

Definition at line 687 of file Structure.cc.

## element_count()

int libdap::Constructor::element_count | ( | bool | leaves = `false` | ) |

virtual inherited

Count the members of constructor types.

Return a count of the total number of variables in this variable. This is used to count the number of variables held by a constructor variable - for simple type and vector variables it always returns 1.

For compound data types, there are two ways to count members. You can count the members, or you can count the simple members and add that to the count of the compound members. For example, if a Structure contains an Int32 and another Structure that itself contains two Int32 members, the element count of the top-level structure could be two (one Int32 and one Structure) or three (one Int32 by itself and two Int32's in the subsidiary Structure). Use the leaves parameter to control which kind of counting you desire.

Returns
  Returns 1 for simple types. For compound members, the count depends on the leaves argument.

Parameters

  leaves | This parameter is only relevant if the object contains other compound data types. If FALSE, the function counts only the data variables mentioned in the object's declaration. If TRUE, it counts the simple members, and adds that to the sum of the counts for the compound members. This parameter has no effect for simple type variables.

Reimplemented from libdap::BaseType.

Definition at line 194 of file Constructor.cc.

## FQN()

string libdap::Constructor::FQN | ( |  | ) | const

virtual inherited

Return the FQN for this variable. This will include the D4 Group component of the name.

Returns
  The FQN in a string

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 181 of file Constructor.cc.

## get_attr_table()

AttrTable & libdap::BaseType::get_attr_table | ( |  | ) |

virtual inherited

Get this variable's AttrTable. It's generally a bad idea to return a reference to a contained object, but in this case it seems that building an interface inside BaseType is overkill.

Use the AttrTable methods to manipulate the table.

Definition at line 573 of file BaseType.cc.

## get_parent()

BaseType * libdap::BaseType::get_parent | ( |  | ) | const

virtual inherited

Return a pointer to the Constructor or Vector which holds (contains) this variable. If this variable is at the top level, this method returns null.

Returns
  A BaseType pointer to the variable's parent.

Definition at line 742 of file BaseType.cc.

## get_var_index()

BaseType * libdap::Constructor::get_var_index | ( | int | i | ) |

inherited

Return the BaseType pointer for the ith variable.

Parameters

  i | This index

Returns
  The corresponding BaseType*.

Definition at line 397 of file Constructor.cc.

## get_vars_iter()

Constructor::Vars_iter libdap::Constructor::get_vars_iter | ( | int | i | ) |

inherited

Return the iterator for the ith variable.

Parameters

  i | the index

Returns
  The corresponding Vars_iter

Definition at line 388 of file Constructor.cc.

## intern_data() [1/2]

void libdap::Constructor::intern_data | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds
| ) |  |

virtual inherited

Similar to using serialize() and deserialize() together in one object. Data are read as for serialize and those values are stored in the objects as deserialize() does but does not write and then read data to/from a stream.

This method is defined by the various data type classes. It calls the read() abstract method. Unlike serialize(), this method does not clear the memory use to hold the data values, so the caller should make sure to delete the DDS or the variable as soon as possible.

Parameters

  eval | Use this as the constraint expression evaluator.
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Sequence, and libdap::D4Sequence.

Definition at line 490 of file Constructor.cc.

## intern_data() [2/2]

void libdap::Constructor::intern_data | ( |  | ) |

virtual inherited

Read data into this variable.

Parameters

  eval | Evaluator for a constraint expression
  dmr | DMR for the whole dataset

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Sequence, and libdap::D4Group.

Definition at line 556 of file Constructor.cc.

## is_constructor_type()

bool libdap::BaseType::is_constructor_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.

Returns
  True if the instance is a Structure, Sequence or Grid, False otherwise.

Definition at line 403 of file BaseType.cc.

## is_in_selection()

bool libdap::BaseType::is_in_selection | ( |  | ) |

virtual inherited

Is this variable part of the current selection?

Does this variable appear in either the selection part or as a function argument in the current constrain expression. If this property is set (true) then implementations of the read() method should read this variable.

Note
  This method does not check, nor does it know about the semantics of, string arguments passed to functions. Those functions might include variable names in strings; they are responsible for reading those variables. See the grid (func_grid_select()) for an example.

See also
  BaseType::read()

Definition at line 694 of file BaseType.cc.

## is_linear()

bool libdap::Structure::is_linear | ( |  | ) |

virtual

Check to see whether this variable can be printed simply.

True if the instance can be flattened and printed as a single table of values. For Arrays and Grids this is always false. For Structures and Sequences the conditions are more complex. The implementation provided by this class always returns false. Other classes should override this implementation.

Todo:
  Change the name to is_flattenable or something like that. 05/16/03 jhrg

Returns
  True if the instance can be printed as a single table of values, false otherwise.

Reimplemented from libdap::Constructor.

Definition at line 262 of file Structure.cc.

## is_simple_type()

bool libdap::BaseType::is_simple_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a numeric, string or URL type variable.

Returns
  True if the instance is a scalar numeric, String or URL variable, False otherwise. Arrays (even of simple types) return False.

See also
  is_vector_type()

Definition at line 384 of file BaseType.cc.

## is_vector_type()

bool libdap::BaseType::is_vector_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a vector (i.e., array) type variable.

Returns
  True if the instance is an Array, False otherwise.

Definition at line 393 of file BaseType.cc.

## length()

virtual int libdap::BaseType::length | ( |  | ) | const

inline virtual inherited

How many elements are in this variable.

Todo:
  change the return type to int64_t

Returns
  The number of elements; 1 for scalars

Reimplemented in libdap::Sequence, libdap::D4Sequence, libdap::Vector, libdap::Str, and libdap::D4Opaque.

Definition at line 207 of file BaseType.h.

## m_duplicate()

void libdap::BaseType::m_duplicate | ( | const BaseType & | bt | ) |

protected inherited

Perform a deep copy.

Perform a deep copy. Copies the values of bt into `*this`. Pointers are dereferenced and their values are copied into a newly allocated instance.

Parameters

  bt | The source object.

Definition at line 85 of file BaseType.cc.

## name()

string libdap::BaseType::name | ( |  | ) | const

virtual inherited

Returns the name of the class instance.

Definition at line 311 of file BaseType.cc.

## ops()

bool libdap::BaseType::ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluate relational operators.

This method contains the relational operators used by the constraint expression evaluator in the DDS class. Each class that wants to be able to evaluate relational expressions must overload this function. The implementation in BaseType throws an InternalErr exception. The DAP library classes Byte, ..., Url provide specializations of this method. It is not meaningful for classes such as Array because relational expressions using Array are not supported.

The op argument refers to a table generated by bison from the constraint expression parser. Use statements like the following to correctly interpret its value:

    switch (op) {
        case EQUAL: return i1 == i2;
        case NOT_EQUAL: return i1 != i2;
        case GREATER: return i1 > i2;
        case GREATER_EQL: return i1 >= i2;
        case LESS: return i1 < i2;
        case LESS_EQL: return i1 <= i2;
        case REGEXP: throw Error("Regular expressions are not supported for integer values");
        default: throw Error("Unknown operator");
    }

This function is used by the constraint expression evaluator.

Parameters

  b | Compare the value of this instance with b.
  op | An integer index indicating which relational operator is implied. Choose one from the following: `EQUAL`, `NOT_EQUAL`, `GREATER`, `GREATER_EQL`, `LESS`, `LESS_EQL`, and `REGEXP`.

Returns
  The boolean value of the comparison.

See also
  BaseType::d4_ops(BaseType *, int)

Reimplemented in libdap::D4Enum, libdap::Str, libdap::Int32, libdap::Float32, libdap::Byte, libdap::Float64, libdap::UInt32, libdap::D4Opaque, libdap::Int16, libdap::UInt16, libdap::Int64, libdap::UInt64, and libdap::Int8.

Definition at line 1247 of file BaseType.cc.

## print_dap4()

void libdap::Constructor::print_dap4 | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the DAP4 XML representation for this variable. This method is used to build the DAP4 DMR response object.

Parameters

  xml | An XMLWriter that will do the serialization
  constrained | True if the response should show the variables subject to the current constraint expression.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 768 of file Constructor.cc.

## print_decl() [1/2]

void libdap::Constructor::print_decl | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 626 of file Constructor.cc.

## print_decl() [2/2]

void libdap::Constructor::print_decl | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 617 of file Constructor.cc.

## print_val() [1/2]

void libdap::Constructor::print_val | ( | FILE * | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

virtual inherited

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Sequence, and libdap::Grid.

Definition at line 650 of file Constructor.cc.

## print_val() [2/2]

void libdap::Constructor::print_val | ( | ostream & | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

virtual inherited

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output ostream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Implements libdap::BaseType.

Reimplemented in libdap::D4Sequence, libdap::Sequence, and libdap::Grid.

Definition at line 658 of file Constructor.cc.

## print_xml() [1/2]

void libdap::Constructor::print_xml | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Deprecated:

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 695 of file Constructor.cc.

## print_xml() [2/2]

void libdap::Constructor::print_xml | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Deprecated:

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 684 of file Constructor.cc.

## print_xml_writer()

void libdap::Constructor::print_xml_writer | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination output stream
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 718 of file Constructor.cc.

## ptr_duplicate()

BaseType * libdap::Structure::ptr_duplicate | ( |  | ) |

virtual

Clone this instance. Allocate a new instance and copy `*this` into it. This method must perform a deep copy.

    @note This method should \e not copy data values, but must copy all
    other fields in the object.

Returns
  A newly allocated copy of `this`.

Implements libdap::BaseType.

Definition at line 137 of file Structure.cc.

## read()

bool libdap::Constructor::read | ( |  | ) |

virtual inherited

simple implementation of read that iterates through vars and calls read on them

Returns
  returns false to signify all has been read

Reimplemented from libdap::BaseType.

Definition at line 476 of file Constructor.cc.

## read_p()

bool libdap::BaseType::read_p | ( |  | ) |

virtual inherited

Has this variable been read?

Returns true if the value(s) for this variable have been read from the data source, otherwise returns false. This method is used to determine when values need to be read using the read() method. When read_p() returns true, this library assumes that buf2val() (and other methods such as get_vec()) can be used to access the value(s) of a variable.

Returns
  True if the variable's value(s) have been read, false otherwise.

Definition at line 471 of file BaseType.cc.

## send_p()

bool libdap::BaseType::send_p | ( |  | ) |

virtual inherited

Should this variable be sent?

Returns the state of the `send_p` property. If true, this variable should be sent to the client, if false, it should not. If no constraint expression (CE) has been evaluated, this property is true for all variables in a data source (i.e., for all the variables listed in a DDS). If a CE has been evaluated, this property is true only for those variables listed in the projection part of the CE.

Returns
  True if the variable should be sent to the client, false otherwise.

Definition at line 545 of file BaseType.cc.

## serialize() [1/2]

bool libdap::Constructor::serialize | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds,
|  | Marshaller & | m,
|  | bool | ce_eval = `true`
| ) |  |

virtual inherited

Move data to the net, then remove them from the object.

Sends the data from the indicated (local) dataset through the connection identified by the Marshaller parameter. If the data is not already incorporated into the DDS object, read the data from the dataset. Once the data are sent (written to the Marshaller), they are deleted from the object and the object state is reset so that they will be read again if the read() method is called.

This function is only used on the server side of the client/server connection, and is generally only called from the ResponseBuilder functions. It has no BaseType implementation; each datatype child class supplies its own implementation.

    @param eval Use this as the constraint expression evaluator.

Parameters

  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure.
  m | A marshaller used to serialize data types
  ce_eval | A boolean value indicating whether to evaluate the DODS constraint expression that may accompany this dataset. The constraint expression is stored in the dds.

Returns
  This method always returns true. Older versions used the return value to signal success or failure.

Note
  We changed the default behavior of this method so that it calls BaseType::clear_local_data() once the values are sent. This, combined with the behavior that read() is called by this method just before data are sent, means that data for any given variable remain in memory for the shortest time possible. Furthermore, since variables are serialized one at a time, no more than one variable's data will be in memory at any given time when using the default behavior. Some code - code that uses intern_data() or server functions - might alter this default behavior. Only Array (i.e. Vector), Sequence, D4Sequence and D4Opaque types actually hold data in dynamically allocated memory, so sonly those types have the new/changed behavior. This change was made on 7/5/15.

Exceptions

  InternalErr. |
  Error. |

See also
  DDS

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Sequence, and libdap::D4Sequence.

Definition at line 504 of file Constructor.cc.

## serialize() [2/2]

void libdap::Constructor::serialize | ( | D4StreamMarshaller & | m,
|  | DMR & | dmr,
|  | bool | filter = `false`
| ) |  |

virtual inherited

Serialize a Constructor.

Todo:
  See notebook for 8/21/14

Parameters

  m |
  dmr | Unused
  eval | Unused
  filter | Unused

Exceptions

  Error | is thrown if the value needs to be read and that operation fails.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Sequence, and libdap::D4Group.

Definition at line 578 of file Constructor.cc.

## set_attr_table()

void libdap::BaseType::set_attr_table | ( | const AttrTable & | at | ) |

virtual inherited

Set this variable's attribute table.

Parameters

  at | Source of the attributes.

Definition at line 581 of file BaseType.cc.

## set_in_selection()

void libdap::Constructor::set_in_selection | ( | bool | state | ) |

virtual inherited

Set the in_selection property.

Set the in_selection property for this variable and all of its children.

Parameters

  state | Set the property value to state.

Reimplemented from libdap::BaseType.

Definition at line 834 of file Constructor.cc.

## set_leaf_sequence()

void libdap::Structure::set_leaf_sequence | ( | int | level = `1` | ) |

virtual

Traverse Structure, set Sequence leaf nodes.

Definition at line 314 of file Structure.cc.

## set_length()

virtual void libdap::BaseType::set_length | ( | int |  | ) |

inline virtual inherited

Set the number of elements for this variable.

Todo:
  change param type to int64_t

Parameters

  l | The number of elements

Reimplemented in libdap::D4Sequence, and libdap::Vector.

Definition at line 214 of file BaseType.h.

## set_name()

void libdap::BaseType::set_name | ( | const string & | n | ) |

virtual inherited

Sets the name of the class instance.

Reimplemented in libdap::Vector.

Definition at line 335 of file BaseType.cc.

## set_parent()

void libdap::BaseType::set_parent | ( | BaseType * | parent | ) |

virtual inherited

Set the `parent` property for this variable.

Note
  Added ability to set parent to null. 10/19/12 jhrg

Parameters

  parent | Pointer to the Constructor of Vector parent variable or null if the variable has no parent (if it is at the top-level of a DAP2/3 DDS).

Exceptions

  InternalErr | thrown if called with anything other than a Constructor, Vector or Null.

Definition at line 724 of file BaseType.cc.

## set_read_p()

void libdap::Constructor::set_read_p | ( | bool | state | ) |

virtual inherited

Sets the value of the read_p property.

Sets the value of the `read_p` property. This indicates that the value(s) of this variable has/have been read. An implementation of the read() method should use this to set the `read_p` property to true.

Note
  If the is_synthesized property is true, this method will not alter the is_read property. If you need that behavior, specialize the method in your subclasses if the various types.
  For most of the types the default implementation of this method is fine. However, if you're building a server which must handle data represented using nested sequences, then you may need to provide a specialization of Sequence::set_read_p(). By default Sequence::set_read_p() recursively sets the read_p property for all child variables to state. For servers where one Sequence reads an outer set of values and another reads an inner set, this is cumbersome. In such a case, it is easier to specialize Sequence::set_read_p() so that it does not recursively set the read_p property for the inner Sequence. Be sure to see the documentation for the read() method!

Todo:
  Look at making synthesized variables easier to implement and at making them more integrated into the overall CE evaluation process. Maybe the code that computes the synthesized var's value should be in the that variable's read() method? This might provide a way to get rid of the awkward 'projection functions' by replacing them with real children of BaseType. It would also provide a way to clean up the way the synthesized_p prop intrudes on the read_p prop.

See also
  BaseType::read()

Parameters

  state | Set the read_p property to this state.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 218 of file Constructor.cc.

## set_send_p()

void libdap::Constructor::set_send_p | ( | bool | state | ) |

virtual inherited

Sets the value of the `send_p` flag. This function is meant to be called from within the constraint evaluator of other code which determines that this variable should be returned to the client. Data are ready to be sent when both the `d_is_send` and `d_is_read` flags are set to TRUE.

Parameters

  state | The logical state to set the `send_p` flag.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 208 of file Constructor.cc.

## set_synthesized_p()

void libdap::BaseType::set_synthesized_p | ( | bool | state | ) |

virtual inherited

Set the synthesized flag. Before setting this flag be sure to set the `read_p()` state. Once this flag is set you cannot alter the state of the `read_p` flag!

See also
  synthesized_p()

Definition at line 454 of file BaseType.cc.

## set_type()

void libdap::BaseType::set_type | ( | const Type & | t | ) |

virtual inherited

Sets the type of the class instance.

Definition at line 363 of file BaseType.cc.

## synthesized_p()

bool libdap::BaseType::synthesized_p | ( |  | ) |

virtual inherited

Returns true if the variable is a synthesized variable. A synthesized variable is one that is added to the dataset by the server (usually with a `projection function'.

Definition at line 443 of file BaseType.cc.

## toString()

string libdap::BaseType::toString | ( |  | ) |

virtual inherited

Write out the object's internal fields in a string. To be used for debugging when regular inspection w/ddd or gdb isn't enough.

Returns
  A string which shows the object's internal stuff.

Reimplemented in libdap::Sequence.

Definition at line 183 of file BaseType.cc.

## transfer_attributes()

void libdap::Constructor::transfer_attributes | ( | AttrTable * | at_container | ) |

virtual inherited

Transfer attributes from a DAS object into this variable. Because of the rough history of the DAS object and the way that various server code built the DAS, this is necessarily a heuristic process. The intent is that this method will be overridden by handlers that need to look for certain patterns in the DAS (e.g., hdf4's odd variable_dim_n; where n = 0, 1, 2, ...) attribute containers.

There should be a one-to-one mapping between variables and attribute containers. However, in some cases one variable has attributes spread across several top level containers and in some cases one container is used by several variables

Note
  This method is technically unnecessary because a server (or client) can easily add attributes directly using the DDS::get_attr_table or BaseType::get_attr_table methods and then poke values in using any of the methods AttrTable provides. This method exists to ease the transition to DDS objects which contain attribute information for the existing servers (Since they all make DAS objects separately from the DDS). They could be modified to use the same AttrTable methods but operate on the AttrTable instances in a DDS/BaseType instead of those in a DAS.

Parameters

  at_container | Transfer attributes from this container.

Returns
  void

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 844 of file Constructor.cc.

## transform_to_dap2()

vector< BaseType * > * libdap::Structure::transform_to_dap2 | ( | AttrTable * | parent_attr_table | ) |

virtual

DAP4 to DAP2 transform.

Return a DAP2 'copy' of the variable.

Returns
  A pointer to the transformed variable

Reimplemented from libdap::BaseType.

Definition at line 179 of file Structure.cc.

## transform_to_dap4()

void libdap::Structure::transform_to_dap4 | ( | D4Group * | root,
|  | Constructor * | container
| ) |  |

virtual

Build a DAP4 Structure.

This code must be subclassed for all but the most trivial cases.

Parameters

  root |
  container |

Returns
  The new variable

Reimplemented from libdap::Constructor.

Definition at line 152 of file Structure.cc.

## type()

Type libdap::BaseType::type | ( |  | ) | const

virtual inherited

Returns the type of the class instance.

Definition at line 356 of file BaseType.cc.

## type_name()

string libdap::BaseType::type_name | ( |  | ) | const

virtual inherited

Returns the type of the class instance as a string.

Definition at line 370 of file BaseType.cc.

## val2buf()

virtual unsigned int libdap::Constructor::val2buf | ( | void * | val,
|  | bool | reuse
| ) |  |

inline virtual inherited

Loads class data.

Store the value pointed to by val in the object's internal buffer. This function does not perform any checks, so users must be sure that the thing pointed to can actually be stored in the object's buffer.

Only simple objects (Int, Float, Byte, and so on) and arrays of these simple objects may be stored using this function. To put data into more complex constructor types, use the functions provided by that class.

Deprecated:
  Use set_value() in the leaf classes.

Parameters

  val | A pointer to the data to be inserted into the class data buffer.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect. This is currently used only in the Vector class.

Returns
  The size (in bytes) of the information copied from val.

See also
  Grid
  Vector::val2buf

Implements libdap::BaseType.

Definition at line 115 of file Constructor.h.

## var() [1/2]

BaseType * libdap::Constructor::var | ( | const string & | name,
|  | bool | exact_match = `true`,
|  | btp_stack * | s = `0`
| ) |  |

virtual inherited

btp_stack no longer needed; use back pointers (BaseType::get_parent())

Reimplemented from libdap::BaseType.

Definition at line 267 of file Constructor.cc.

## var() [2/2]

BaseType * libdap::Constructor::var | ( | const string & | n,
|  | btp_stack & | s
| ) |  |

virtual inherited

Deprecated:

Deprecated:
  See comment in BaseType

Reimplemented from libdap::BaseType.

Definition at line 279 of file Constructor.cc.

## var_begin()

Constructor::Vars_iter libdap::Constructor::var_begin | ( |  | ) |

inherited

Returns an iterator referencing the first structure element.

Definition at line 356 of file Constructor.cc.

## var_end()

Constructor::Vars_iter libdap::Constructor::var_end | ( |  | ) |

inherited

Returns an iterator referencing the end of the list of structure elements. Does not reference the last structure element.

Definition at line 364 of file Constructor.cc.

## var_rbegin()

Constructor::Vars_riter libdap::Constructor::var_rbegin | ( |  | ) |

inherited

Return a reverse iterator that references the last element.

Definition at line 371 of file Constructor.cc.

## var_rend()

Constructor::Vars_riter libdap::Constructor::var_rend | ( |  | ) |

inherited

Return a reverse iterator that references a point 'before' the first element.

Definition at line 379 of file Constructor.cc.

## width()

unsigned int libdap::Constructor::width | ( | bool | constrained = `false` | ) | const

virtual inherited

This version of width simply returns the same thing as width() for simple types and Arrays. For Structure it returns the total size if constrained is false, or the size of the elements in the current projection if true.

Parameters

  constrained | If true, return the size after applying a constraint.

Returns
  The number of bytes used by the variable.

Reimplemented from libdap::BaseType.

Definition at line 249 of file Constructor.cc.

The documentation for this class was generated from the following files:

- Structure.h
- Structure.cc